"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "createBabelPluginChain", {
  enumerable: true,
  get: function() {
    return createBabelPluginChain;
  }
});
const createBabelPluginChain = () => {
  let plugins = [];
  const blacks = [];
  const plugin = (name) => {
    const pluginExist = plugins.find((plugin3) => plugin3.name === name);
    const isExist = Boolean(pluginExist);
    const plugin2 = pluginExist || {
      name,
      options: []
    };
    const tap = (options2) => {
      plugin2.options = options2;
      set();
    };
    const options = () => plugin2.options;
    const del = () => {
      if (isExist) {
        plugins = plugins.filter((plugin3) => !plugin3.name.includes(name));
      }
    };
    const ban = () => {
      if (!blacks.includes(name)) {
        blacks.push(name);
      }
      del();
    };
    const set = () => {
      if (blacks.includes(name)) {
        throw new Error(`Plugin: ${name} has been banned!, You can't set it.`);
      }
      if (!isExist) {
        plugins.push(plugin2);
      }
    };
    const use = (path, options2) => {
      plugin2.path = path;
      plugin2.options = options2 || [];
      set();
    };
    return {
      tap,
      delete: del,
      ban,
      options,
      filter: plugins.filter,
      use
    };
  };
  const toJSON = () => plugins.map((plugin2) => plugin2.options ? [
    plugin2.path || plugin2.name,
    ...plugin2.options
  ] : plugin2.path || plugin2.name);
  const merge = (other) => {
    for (const plugin2 of other.plugins) {
      if (plugin2.path) {
        chain.plugin(plugin2.name).use(plugin2.path, plugin2.options);
      } else {
        chain.plugin(plugin2.name).tap(plugin2.options);
      }
    }
    return chain;
  };
  const chain = {
    plugin,
    plugins,
    blacks,
    toJSON,
    merge
  };
  return chain;
};
